"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const R = __importStar(require("ramda"));
const resolveType_1 = __importDefault(require("./resolveType"));
const generateProperties = (details, generateFor, config) => {
    const ps = details.kind === 'compositeType' ? details.attributes : details.columns;
    const sortedPs = config.propertySortFunction
        ? R.sort(config.propertySortFunction, ps)
        : ps;
    const result = sortedPs.map((p) => {
        const { name, comment, typeOverride, nullableOverride, optionalOverride, } = config.getPropertyMetadata(p, details, generateFor, config);
        const canBeOptional = p.isNullable || p.defaultValue || p.isIdentity;
        const t = typeOverride !== null && typeOverride !== void 0 ? typeOverride : (0, resolveType_1.default)(p, details, config);
        let typeName;
        let typeImports = [];
        if (typeof t === 'string') {
            typeName = t;
        }
        else {
            typeName = t.name;
            typeImports = t.typeImports;
        }
        let isOptional;
        if (optionalOverride === undefined) {
            switch (generateFor) {
                case 'selector': {
                    isOptional = false;
                    break;
                }
                case 'initializer': {
                    isOptional = canBeOptional;
                    break;
                }
                case 'mutator': {
                    isOptional = true;
                    break;
                }
                default: {
                    throw new Error(`Unexpected generateFor value: ${generateFor}`);
                }
            }
        }
        else {
            isOptional = optionalOverride;
        }
        const isNullable = Boolean(nullableOverride !== null && nullableOverride !== void 0 ? nullableOverride : p.isNullable);
        return {
            name,
            comment,
            dimensions: p.isArray ? 1 : 0,
            isNullable,
            isOptional,
            typeName,
            typeImports,
        };
    });
    return result;
};
exports.default = generateProperties;
